/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package com.evernote.edam.notestore;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import com.evernote.edam.util.BitSet;
import java.util.Arrays;

import org.apache.thrift.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.protocol.*;

/**
 * Identfying information about previous versions of a note that are backed up
 * within Evernote's servers.  Used in the return value of the listNoteVersions
 * call.
 * 
 * <dl>
 *  <dt>updateSequenceNum</dtd>
 *  <dd>
 *    The update sequence number for the Note when it last had this content.
 *    This serves to uniquely identify each version of the note, since USN
 *    values are unique within an account for each update.
 *  </dd>
 *  <dt>updated</dtd>
 *  <dd>
 *    The 'updated' time that was set on the Note when it had this version
 *    of the content.  This is the user-modifiable modification time on the
 *    note, so it's not reliable for guaranteeing the order of various
 *    versions.  (E.g. if someone modifies the note, then changes this time
 *    manually into the past and then updates the note again.)
 *  </dd>
 *  <dt>serviceUpdated</dtd>
 *  <dd>
 *    A timestamp that holds the date and time when the Note that had this
 *    version of the content was saved or synchronized on the service.  This
 *    may be different than the 'updated' time visible on the note in a client,
 *    which is a user-editable field that is (therefore) not reliable for
 *    determining the order of changes.
 *  </dd>
 * </dl>
 */
public class NoteVersionId implements TBase<NoteVersionId._Fields>, java.io.Serializable, Cloneable, Comparable<NoteVersionId> {
  private static final TStruct STRUCT_DESC = new TStruct("NoteVersionId");

  private static final TField UPDATE_SEQUENCE_NUM_FIELD_DESC = new TField("updateSequenceNum", TType.I32, (short)1);
  private static final TField UPDATED_FIELD_DESC = new TField("updated", TType.I64, (short)2);
  private static final TField SERVICE_UPDATED_FIELD_DESC = new TField("serviceUpdated", TType.I64, (short)3);

  private int updateSequenceNum;
  private long updated;
  private long serviceUpdated;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    UPDATE_SEQUENCE_NUM((short)1, "updateSequenceNum"),
    UPDATED((short)2, "updated"),
    SERVICE_UPDATED((short)3, "serviceUpdated");

    private static final Map<Integer, _Fields> byId = new HashMap<Integer, _Fields>();
    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byId.put((int)field._thriftId, field);
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      return byId.get(fieldId);
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __UPDATESEQUENCENUM_ISSET_ID = 0;
  private static final int __UPDATED_ISSET_ID = 1;
  private static final int __SERVICEUPDATED_ISSET_ID = 2;
  private BitSet __isset_bit_vector = new BitSet(3);

  public static final Map<_Fields, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new EnumMap<_Fields, FieldMetaData>(_Fields.class) {{
    put(_Fields.UPDATE_SEQUENCE_NUM, new FieldMetaData("updateSequenceNum", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I32)));
    put(_Fields.UPDATED, new FieldMetaData("updated", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I64)));
    put(_Fields.SERVICE_UPDATED, new FieldMetaData("serviceUpdated", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I64)));
  }});

  static {
    FieldMetaData.addStructMetaDataMap(NoteVersionId.class, metaDataMap);
  }

  public NoteVersionId() {
  }

  public NoteVersionId(
    int updateSequenceNum,
    long updated,
    long serviceUpdated)
  {
    this();
    this.updateSequenceNum = updateSequenceNum;
    setUpdateSequenceNumIsSet(true);
    this.updated = updated;
    setUpdatedIsSet(true);
    this.serviceUpdated = serviceUpdated;
    setServiceUpdatedIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public NoteVersionId(NoteVersionId other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    this.updateSequenceNum = other.updateSequenceNum;
    this.updated = other.updated;
    this.serviceUpdated = other.serviceUpdated;
  }

  public NoteVersionId deepCopy() {
    return new NoteVersionId(this);
  }

  @Deprecated
  public NoteVersionId clone() {
    return new NoteVersionId(this);
  }

  public int getUpdateSequenceNum() {
    return this.updateSequenceNum;
  }

  public void setUpdateSequenceNum(int updateSequenceNum) {
    this.updateSequenceNum = updateSequenceNum;
    setUpdateSequenceNumIsSet(true);
  }

  public void unsetUpdateSequenceNum() {
    __isset_bit_vector.clear(__UPDATESEQUENCENUM_ISSET_ID);
  }

  /** Returns true if field updateSequenceNum is set (has been asigned a value) and false otherwise */
  public boolean isSetUpdateSequenceNum() {
    return __isset_bit_vector.get(__UPDATESEQUENCENUM_ISSET_ID);
  }

  public void setUpdateSequenceNumIsSet(boolean value) {
    __isset_bit_vector.set(__UPDATESEQUENCENUM_ISSET_ID, value);
  }

  public long getUpdated() {
    return this.updated;
  }

  public void setUpdated(long updated) {
    this.updated = updated;
    setUpdatedIsSet(true);
  }

  public void unsetUpdated() {
    __isset_bit_vector.clear(__UPDATED_ISSET_ID);
  }

  /** Returns true if field updated is set (has been asigned a value) and false otherwise */
  public boolean isSetUpdated() {
    return __isset_bit_vector.get(__UPDATED_ISSET_ID);
  }

  public void setUpdatedIsSet(boolean value) {
    __isset_bit_vector.set(__UPDATED_ISSET_ID, value);
  }

  public long getServiceUpdated() {
    return this.serviceUpdated;
  }

  public void setServiceUpdated(long serviceUpdated) {
    this.serviceUpdated = serviceUpdated;
    setServiceUpdatedIsSet(true);
  }

  public void unsetServiceUpdated() {
    __isset_bit_vector.clear(__SERVICEUPDATED_ISSET_ID);
  }

  /** Returns true if field serviceUpdated is set (has been asigned a value) and false otherwise */
  public boolean isSetServiceUpdated() {
    return __isset_bit_vector.get(__SERVICEUPDATED_ISSET_ID);
  }

  public void setServiceUpdatedIsSet(boolean value) {
    __isset_bit_vector.set(__SERVICEUPDATED_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case UPDATE_SEQUENCE_NUM:
      if (value == null) {
        unsetUpdateSequenceNum();
      } else {
        setUpdateSequenceNum((Integer)value);
      }
      break;

    case UPDATED:
      if (value == null) {
        unsetUpdated();
      } else {
        setUpdated((Long)value);
      }
      break;

    case SERVICE_UPDATED:
      if (value == null) {
        unsetServiceUpdated();
      } else {
        setServiceUpdated((Long)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case UPDATE_SEQUENCE_NUM:
      return new Integer(getUpdateSequenceNum());

    case UPDATED:
      return new Long(getUpdated());

    case SERVICE_UPDATED:
      return new Long(getServiceUpdated());

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case UPDATE_SEQUENCE_NUM:
      return isSetUpdateSequenceNum();
    case UPDATED:
      return isSetUpdated();
    case SERVICE_UPDATED:
      return isSetServiceUpdated();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof NoteVersionId)
      return this.equals((NoteVersionId)that);
    return false;
  }

  public boolean equals(NoteVersionId that) {
    if (that == null)
      return false;

    boolean this_present_updateSequenceNum = true;
    boolean that_present_updateSequenceNum = true;
    if (this_present_updateSequenceNum || that_present_updateSequenceNum) {
      if (!(this_present_updateSequenceNum && that_present_updateSequenceNum))
        return false;
      if (this.updateSequenceNum != that.updateSequenceNum)
        return false;
    }

    boolean this_present_updated = true;
    boolean that_present_updated = true;
    if (this_present_updated || that_present_updated) {
      if (!(this_present_updated && that_present_updated))
        return false;
      if (this.updated != that.updated)
        return false;
    }

    boolean this_present_serviceUpdated = true;
    boolean that_present_serviceUpdated = true;
    if (this_present_serviceUpdated || that_present_serviceUpdated) {
      if (!(this_present_serviceUpdated && that_present_serviceUpdated))
        return false;
      if (this.serviceUpdated != that.serviceUpdated)
        return false;
    }

    return true;
  }

  public int hashCode() {
    return 0;
  }

  public int compareTo(NoteVersionId other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    NoteVersionId typedOther = (NoteVersionId)other;

    lastComparison = Boolean.valueOf(isSetUpdateSequenceNum()).compareTo(isSetUpdateSequenceNum());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(updateSequenceNum, typedOther.updateSequenceNum);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetUpdated()).compareTo(isSetUpdated());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(updated, typedOther.updated);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetServiceUpdated()).compareTo(isSetServiceUpdated());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(serviceUpdated, typedOther.serviceUpdated);
    if (lastComparison != 0) {
      return lastComparison;
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      _Fields fieldId = _Fields.findByThriftId(field.id);
      if (fieldId == null) {
        TProtocolUtil.skip(iprot, field.type);
      } else {
        switch (fieldId) {
          case UPDATE_SEQUENCE_NUM:
            if (field.type == TType.I32) {
              this.updateSequenceNum = iprot.readI32();
              setUpdateSequenceNumIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case UPDATED:
            if (field.type == TType.I64) {
              this.updated = iprot.readI64();
              setUpdatedIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case SERVICE_UPDATED:
            if (field.type == TType.I64) {
              this.serviceUpdated = iprot.readI64();
              setServiceUpdatedIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
        }
        iprot.readFieldEnd();
      }
    }
    iprot.readStructEnd();
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    oprot.writeFieldBegin(UPDATE_SEQUENCE_NUM_FIELD_DESC);
    oprot.writeI32(this.updateSequenceNum);
    oprot.writeFieldEnd();
    oprot.writeFieldBegin(UPDATED_FIELD_DESC);
    oprot.writeI64(this.updated);
    oprot.writeFieldEnd();
    oprot.writeFieldBegin(SERVICE_UPDATED_FIELD_DESC);
    oprot.writeI64(this.serviceUpdated);
    oprot.writeFieldEnd();
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  public String toString() {
    StringBuilder sb = new StringBuilder("NoteVersionId(");
    boolean first = true;

    sb.append("updateSequenceNum:");
    sb.append(this.updateSequenceNum);
    first = false;
    if (!first) sb.append(", ");
    sb.append("updated:");
    sb.append(this.updated);
    first = false;
    if (!first) sb.append(", ");
    sb.append("serviceUpdated:");
    sb.append(this.serviceUpdated);
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
    if (!isSetUpdateSequenceNum()) {
      throw new TProtocolException("Required field 'updateSequenceNum' is unset! Struct:" + toString());
    }

    if (!isSetUpdated()) {
      throw new TProtocolException("Required field 'updated' is unset! Struct:" + toString());
    }

    if (!isSetServiceUpdated()) {
      throw new TProtocolException("Required field 'serviceUpdated' is unset! Struct:" + toString());
    }

  }

}

